package service

// Code generated by gowrap. DO NOT EDIT.
// template: ../../../assets/templates/middleware/access_log
// gowrap: http://github.com/hexdigest/gowrap

//go:generate gowrap gen -p git.perx.ru/perxis/perxis-go/pkg/references -i References -t ../../../assets/templates/middleware/access_log -o logging_middleware.go -l ""

import (
	"context"
	"fmt"
	"time"

	"git.perx.ru/perxis/perxis-go/pkg/auth"
	"git.perx.ru/perxis/perxis-go/pkg/items"
	"git.perx.ru/perxis/perxis-go/pkg/references"
	"go.uber.org/zap"
	"go.uber.org/zap/zapcore"
)

// loggingMiddleware implements references.References that is instrumented with logging
type loggingMiddleware struct {
	logger *zap.Logger
	next   references.References
}

// LoggingMiddleware instruments an implementation of the references.References with simple logging
func LoggingMiddleware(logger *zap.Logger) Middleware {
	return func(next references.References) references.References {
		return &loggingMiddleware{
			next:   next,
			logger: logger,
		}
	}
}

func (m *loggingMiddleware) Get(ctx context.Context, spaceId string, envId string, references []*references.Reference) (items []*items.Item, notfound []*references.Reference, err error) {
	begin := time.Now()
	var fields []zapcore.Field
	for k, v := range map[string]interface{}{
		"ctx":        ctx,
		"spaceId":    spaceId,
		"envId":      envId,
		"references": references} {
		if k == "ctx" {
			fields = append(fields, zap.String("principal", fmt.Sprint(auth.GetPrincipal(ctx))))
			continue
		}
		fields = append(fields, zap.Reflect(k, v))
	}

	m.logger.Debug("Get.Request", fields...)

	items, notfound, err = m.next.Get(ctx, spaceId, envId, references)

	fields = []zapcore.Field{
		zap.Duration("time", time.Since(begin)),
		zap.Error(err),
	}

	for k, v := range map[string]interface{}{
		"items":    items,
		"notfound": notfound,
		"err":      err} {
		if k == "err" {
			continue
		}
		fields = append(fields, zap.Reflect(k, v))
	}

	m.logger.Debug("Get.Response", fields...)

	return items, notfound, err
}
